using Face;
using Grpc.Core;
using Google.Protobuf;
using System;

namespace example
{
  class FaceSvc
  {
    private Face.Face.FaceClient faceClient;

    public FaceSvc(Channel channel) {
      faceClient = new Face.Face.FaceClient(channel);
    }

    public FaceData Scan(uint deviceID, FaceEnrollThreshold enrollThreshold) {
      var request = new ScanRequest{ DeviceID = deviceID, EnrollThreshold = enrollThreshold };
      var response = faceClient.Scan(request);

      return response.FaceData;
    }

    public ByteString Normalize(uint deviceID, ByteString unwrappedImageData) {
      var request = new NormalizeRequest{DeviceID = deviceID, UnwrappedImageData = unwrappedImageData};
      var response = faceClient.Normalize(request);

      return response.WrappedImageData;
    }

    public FaceConfig GetConfig(uint deviceID) {
      var request = new Face.GetConfigRequest{ DeviceID = deviceID };
      var response = faceClient.GetConfig(request);

      return response.Config;
    }
  }
}